##################################################################
##  
##  Aseryla project [http://aseryla.16mb.com]
##  Information Verification task
##
##

import glob
import gzip
import re
import os





##  LANGUAGE HELPER ####################################################################################################################
 
def loadListFile(filename):
    try:
        f = open(filename, 'r')
        content = eval(f.read())
        f.close()
    except:
        content = {}
         
    return content
 
class PorterStemmer:
 
    def __init__(self):
        self.b = ""  
        self.k = 0
        self.k0 = 0
        self.j = 0  
 
    def cons(self, i):
        if self.b[i] == 'a' or self.b[i] == 'e' or self.b[i] == 'i' or self.b[i] == 'o' or self.b[i] == 'u': return 0
        if self.b[i] == 'y':
            if i == self.k0: return 1
            else: return (not self.cons(i - 1))
        return 1
 
    def m(self):
        n = 0
        i = self.k0
        while 1:
            if i > self.j:
                return n
            if not self.cons(i):
                break
            i = i + 1
        i = i + 1
        while 1:
            while 1:
                if i > self.j:
                    return n
                if self.cons(i):
                    break
                i = i + 1
            i = i + 1
            n = n + 1
            while 1:
                if i > self.j:
                    return n
                if not self.cons(i):
                    break
                i = i + 1
            i = i + 1
 
    def vowelinstem(self):
        for i in range(self.k0, self.j + 1):
            if not self.cons(i): return 1
        return 0
 
    def doublec(self, j):
        if j < (self.k0 + 1): return 0
        if (self.b[j] != self.b[j-1]): return 0
        return self.cons(j)
 
    def cvc(self, i):
        if i < (self.k0 + 2) or not self.cons(i) or self.cons(i-1) or not self.cons(i-2): return 0
        ch = self.b[i]
        if ch == 'w' or ch == 'x' or ch == 'y': return 0
        return 1
 
    def ends(self, s):
        length = len(s)
        if s[length - 1] != self.b[self.k]: return 0
        if length > (self.k - self.k0 + 1): return 0
        if self.b[self.k-length+1:self.k+1] != s: return 0
        self.j = self.k - length
        return 1
 
    def setto(self, s):
        length = len(s)
        self.b = self.b[:self.j+1] + s + self.b[self.j+length+1:]
        self.k = self.j + length
 
    def r(self, s):
        if self.m() > 0: self.setto(s)
 
    def step1ab(self):
        if self.b[self.k] == 's':
            if self.ends("sses"):
                self.k = self.k - 2
            elif self.ends("ies"):
                self.setto("i")
            elif self.b[self.k - 1] != 's':
                self.k = self.k - 1
        if self.ends("eed"):
            if self.m() > 0:
                self.k = self.k - 1
        elif (self.ends("ed") or self.ends("ing")) and self.vowelinstem():
            self.k = self.j
            if self.ends("at"):   self.setto("ate")
            elif self.ends("bl"): self.setto("ble")
            elif self.ends("iz"): self.setto("ize")
            elif self.doublec(self.k):
                self.k = self.k - 1
                ch = self.b[self.k]
                if ch == 'l' or ch == 's' or ch == 'z':
                    self.k = self.k + 1
            elif (self.m() == 1 and self.cvc(self.k)):
                self.setto("e")
 
    def step1c(self):
        if (self.ends("y") and self.vowelinstem()):
            self.b = self.b[:self.k] + 'i' + self.b[self.k+1:]
 
    def step2(self):
        if self.b[self.k - 1] == 'a':
            if self.ends("ational"):   self.r("ate")
            elif self.ends("tional"):  self.r("tion")
        elif self.b[self.k - 1] == 'c':
            if self.ends("enci"):      self.r("ence")
            elif self.ends("anci"):    self.r("ance")
        elif self.b[self.k - 1] == 'e':
            if self.ends("izer"):      self.r("ize")
        elif self.b[self.k - 1] == 'l':
            if self.ends("abli"):      self.r("able")
            elif self.ends("alli"):    self.r("al")
            elif self.ends("entli"):   self.r("ent")
            elif self.ends("eli"):     self.r("e")
            elif self.ends("ousli"):   self.r("ous")
        elif self.b[self.k - 1] == 'o':
            if self.ends("ization"):   self.r("ize")
            elif self.ends("ation"):   self.r("ate")
            elif self.ends("ator"):    self.r("ate")
        elif self.b[self.k - 1] == 's':
            if self.ends("alism"):     self.r("al")
            elif self.ends("iveness"): self.r("ive")
            elif self.ends("fulness"): self.r("ful")
            elif self.ends("ousness"): self.r("ous")
        elif self.b[self.k - 1] == 't':
            if self.ends("aliti"):     self.r("al")
            elif self.ends("iviti"):   self.r("ive")
            elif self.ends("biliti"):  self.r("ble")
 
    def step3(self):
        if self.b[self.k] == 'e':
            if self.ends("icate"):     self.r("ic")
            elif self.ends("ative"):   self.r("")
            elif self.ends("alize"):   self.r("al")
        elif self.b[self.k] == 'i':
            if self.ends("iciti"):     self.r("ic")
        elif self.b[self.k] == 'l':
            if self.ends("ical"):      self.r("ic")
            elif self.ends("ful"):     self.r("")
        elif self.b[self.k] == 's':
            if self.ends("ness"):      self.r("")
 
    def step4(self):
        if self.b[self.k - 1] == 'a':
            if self.ends("al"): pass
            else: return
        elif self.b[self.k - 1] == 'c':
            if self.ends("ance"): pass
            elif self.ends("ence"): pass
            else: return
        elif self.b[self.k - 1] == 'e':
            if self.ends("er"): pass
            else: return
        elif self.b[self.k - 1] == 'i':
            if self.ends("ic"): pass
            else: return
        elif self.b[self.k - 1] == 'l':
            if self.ends("able"): pass
            elif self.ends("ible"): pass
            else: return
        elif self.b[self.k - 1] == 'n':
            if self.ends("ant"): pass
            elif self.ends("ement"): pass
            elif self.ends("ment"): pass
            elif self.ends("ent"): pass
            else: return
        elif self.b[self.k - 1] == 'o':
            if self.ends("ion") and (self.b[self.j] == 's' or self.b[self.j] == 't'): pass
            elif self.ends("ou"): pass
            else: return
        elif self.b[self.k - 1] == 's':
            if self.ends("ism"): pass
            else: return
        elif self.b[self.k - 1] == 't':
            if self.ends("ate"): pass
            elif self.ends("iti"): pass
            else: return
        elif self.b[self.k - 1] == 'u':
            if self.ends("ous"): pass
            else: return
        elif self.b[self.k - 1] == 'v':
            if self.ends("ive"): pass
            else: return
        elif self.b[self.k - 1] == 'z':
            if self.ends("ize"): pass
            else: return
        else: return
        if self.m() > 1: self.k = self.j
 
    def step5(self):
        self.j = self.k
        if self.b[self.k] == 'e':
            a = self.m()
            if a > 1 or (a == 1 and not self.cvc(self.k-1)):
                self.k = self.k - 1
        if self.b[self.k] == 'l' and self.doublec(self.k) and self.m() > 1:
            self.k = self.k -1
 
    def stem(self, p):
        self.b = p
        self.k = len(p)-1
        self.k0 = 0
        if self.k <= self.k0 + 1: return self.b 
 
        self.step1ab()
        self.step1c()
        self.step2()
        self.step3()
        self.step4()
        self.step5()
        return self.b[self.k0:self.k+1]
 
 
 
 
# check if a text is writed in English or not
# based on check if every word in the text exist into the English dictionary
# if the number of non English language words is lower then assumes is an English text
def isEnglish(text):
 
    # extract the words in the text
    # (limited to about 10000 words, assuming is enough to detect it)
    # the comparison must be in lowercase and the punctuation and numbers must be removed
    text = re.sub("[^a-z]", ' ', text[:10000].lower())
     
    ts = []
    for t in text.split():
        try:
            t = porter.stem(str(t))
            if len(t) > 1:
                ts.append(t)
        except:
            pass
 
    text_vocab = set(ts)
    size_vocab = len(text_vocab) * 1.0
    if size_vocab == 0:
        return False
    
 
    # how percetage of words are "unknown"
    unusual = text_vocab.difference(english_vocab)
    # if the percent is not higher than a threshold
    # (it can't be zero, due to proper nouns and others)
    percent = ((size_vocab - len(unusual)) / size_vocab)
 
    #print unusual, percent
    #if size_vocab < 6: return percent > 0.49 else: return percent > 0.79
    return  percent > 0.49
     
 
## ----------------------------------------------------------------------------------------------------------------------------------------------
 
 



porter = PorterStemmer()
english_vocab = loadListFile("english.dic")

fs = open("non_semantics.txt", 'rt')
stop_words = eval(fs.read())
fs.close()

while True:

    files = glob.glob('*.gz')

    if len(files) == 0:
        print "no files"
        break

    files.sort()
    
    for filename in files:
        print filename

        lines = 0
        tot = 0
        last = ""
        dd = {}


        with gzip.open(filename, 'rb') as f:
            for line in f:

                lines = lines + 1
                if len(line.strip()) == 0:
                    continue
                
                bigram = line.split("\t")[0]
                if bigram != last:
                    last = bigram
                    bigram = bigram.lower().replace("_noun", "").replace("_adj", "").replace("_verb", "").replace("_pron", "").replace("_det", "").replace("_adv", "")

                    tot = tot + 1

                    if not '.' in re.sub("[^-a-zA-Z ]", '.', bigram):

                        pair = bigram.split(" ")
                        if len(pair) != 2:
                            print pair
                            continue
                        
                        if len(pair[0]) == 1 or len(pair[1]) == 1 or pair[0] in stop_words or pair[1] in stop_words:
                            continue

                        ll = [pair[1]]
                        if pair[0] in dd:
                            ll = dd[pair[0]]
                            ll.append(pair[1])

                        dd[pair[0]] = ll                        
                        
                        

        print lines, tot, len(dd)

        fw = open(filename[-5:][:2] + ".txt", 'wt')
        for d in dd:

            elems = list(set(dd[d]))
            nb = 0
            for e in elems:
                if len(e) < 4:
                    nb = nb + 1

            if nb < len(elems):
                if d in elems:
                    elems.remove(d)
                txt = d + " " + ' '.join(elems) + "\n"
                if isEnglish(txt):
                   fw.write(txt)
        
        fw.close()

        os.remove(filename)





